# -*- coding:utf-8 -*-
import os

import django
from lxml.objectify import ObjectifiedElement

os.environ['DJANGO_SETTINGS_MODULE'] = 'starpro.settings'
django.setup()
print os.environ.get('DJANGO_SETTINGS_MODULE')
import time
import urllib2
import socket
from sale_amazon.interface.inter.Amazon_api import Amazon_MWS,Amazon_AWS
from order.models.account_models import Amazon_Account
from sale_amazon.models.listing import AmazonListingProductMethod,AmazonListingMethod,AmazonListingVariationsMethod, \
    AmazonListing,create_listing_and_variations,AmazonListingVariations
from sale_amazon.utils import *
from sale_amazon.config import *

ss = ObjectifiedElement()
def test_sync():
    error_num = 0
    time_out_request_base = []
    time_out_sale_rank = []
    # for item in [486]:
    for item in [486]:
        if item == "":
            continue
        try:
            account = Amazon_Account.objects.get(idamazon_account=item)
            # if account.MKPLACEID == 'ATVPDKIKX0DER' or account.MKPLACEID=='A2EUQ1WTGCTBG2':
            if True:
                print account
                my_mws = Amazon_MWS(account)
                return_data = my_mws.get_product_report(type='_GET_MERCHANT_LISTINGS_DATA_')
                # print len(return_data)
                # print return_data
                # print list(set([key.get('asin1') for key in return_data]))
                time_out_request_base = create_amazon_listing_product(list(set([key.get('asin1') for key in return_data])),account)
                request_num = 0
                while len(time_out_request_base)>0:
                    print "have not request"
                    request_num +=1
                    if request_num >3:
                        break
                    print time_out_request_base
                    time_out_request_base = create_amazon_listing_product(time_out_request_base, account)
                print "************************************************************************************************"
                time_out_request_relationship = create_relationship(return_data,account,my_mws)
                request_num = 0
                while len(time_out_request_relationship)>0:
                    print "have not request,time_out_request_relationship"
                    request_num +=1
                    if request_num >3:
                        break
                    print time_out_request_relationship
                    time_out_request_relationship = create_amazon_listing_product(time_out_request_relationship, account)
        except Exception,e:
            print str(e)
            error_num +=1
            # account.sync_time = timezone.now()
            # account.sync_status = 0
            # account.save()
    return error_num


def create_amazon_listing_product(asins,account):
    time_out_request_base = []
    time_out_sale_rank = []
    request_asin = []
    i=0
    for asin in asins:
        if not asin:
            continue
        request_asin.append(asin)
        i += 1
        if len(request_asin) >= 10:
            my_aws = Amazon_AWS()
            time.sleep(5)
            print request_asin
            large_product_info = {}
            try:
                large_product_info = my_aws.get_product_large(request_asin,local=MARKET_TO_REGION.get(account.MKPLACEID))
            except Exception, e:
                print "base,first", e
                num = 0
                while num <= 5:
                    time.sleep(5)
                    print "start"
                    try:
                        large_product_info = my_aws.get_product_large(request_asin,local=MARKET_TO_REGION.get(account.MKPLACEID))
                    except Exception, e:
                        print "base,second",num,e
                    if large_product_info:
                        print "chenggong"
                        break
                    num += 1
                if not large_product_info:
                    print "zuizong ni hai shi meiyou ,ni hai you jihui"
                    time_out_request_base.extend(request_asin)
                else:
                    print large_product_info
            AmazonListingProductMethod.create_amazon_listing_product(large_product_info, account)
            my_aws = Amazon_AWS()
            time.sleep(5)
            try:
                sale_ranks = my_aws.get_product_sales_rank(request_asin, local=MARKET_TO_REGION.get(account.MKPLACEID))
            except Exception, e:
                time.sleep(5)
                try:
                    sale_ranks = my_aws.get_product_sales_rank(request_asin, local=MARKET_TO_REGION.get(
                        account.MKPLACEID))
                except Exception, e:
                    sale_ranks = {}
                    time_out_sale_rank.extend(request_asin)
            AmazonListingProductMethod.set_listing_product_sale_rank(sale_ranks)
            request_asin = []
        print i
    if len(request_asin) > 0:
        time.sleep(5)
        my_aws = Amazon_AWS()
        large_product_info = {}
        try:
            large_product_info = my_aws.get_product_large(request_asin,
                                                          local=MARKET_TO_REGION.get(account.MKPLACEID))
        except Exception, e:
            print "base,first",e
            num = 0
            while num<=5 :
                time.sleep(5)
                try:
                    large_product_info = my_aws.get_product_large(request_asin,
                                                                  local=MARKET_TO_REGION.get(account.MKPLACEID))
                except Exception, e:
                    print "base,second", num, e
                    pass
                if large_product_info:
                    print "chenggong"
                    break
                num +=1
            if not large_product_info:
                print "zuizong ni hai shi meiyou ,ni hai you jihui"
                time_out_request_base.extend(request_asin)
            else:
                print large_product_info
        AmazonListingProductMethod.create_amazon_listing_product(large_product_info, account)
        my_aws = Amazon_AWS()
        time.sleep(5)
        try:
            sale_ranks = my_aws.get_product_sales_rank(request_asin,
                                                       local=MARKET_TO_REGION.get(account.MKPLACEID))
        except Exception, e:
            time.sleep(5)
            try:
                sale_ranks = my_aws.get_product_sales_rank(request_asin, local=MARKET_TO_REGION.get(
                    account.MKPLACEID))
            except Exception, e:
                sale_ranks = {}
                time_out_sale_rank.extend(request_asin)
        AmazonListingProductMethod.set_listing_product_sale_rank(sale_ranks)
    print "信息录入完毕,总共录入了:", i, '条'
    print len(time_out_request_base)
    return time_out_request_base


def create_relationship(return_data,account,my_mws):
    time_out_request = []
    i = 0
    aws_request_product = []
    for return_product in return_data:  ## report获取数据，如果是fba直接存到 listing和lisitngvariation表中
        if not return_product:
            continue
        asin = return_product.get('asin1')
        print asin, return_product.get('fulfillment-channel')
        if return_product.get('fulfillment-channel') == "AMAZON_NA":
            i += 1
            parent_amazon_listing = AmazonListingMethod.create_amazon_listing_by_report(account, asin, 2,
                                                                                        return_product)
            AmazonListingVariationsMethod.create_amazon_variations_by_report(parent_amazon_listing, asin, account,
                                                                             return_product)
        else:  # report获取数据，如果不是是fba，我们通过aws来获取父子关系,先保存起来，后面十个十个的来获取关系
            aws_request_product.append(return_product)
    time.sleep(10)
    FBA_return_data = []
    print "----------------------------------------------------------"
    try:
        FBA_return_data = my_mws.get_product_report(type='_GET_AFN_INVENTORY_DATA_')
    except:
        num = 0
        while num<=10:
            try:
                FBA_return_data = my_mws.get_product_report(type='_GET_AFN_INVENTORY_DATA_')
            except Exception,e:
                print 'shibai ',i,str(e)
                FBA_return_data = []
            if FBA_return_data:
                print "success"
                break
            num +=1
    for FBA_quantity in FBA_return_data:
        print FBA_quantity
        if FBA_quantity.get('Warehouse-Condition-code') == 'SELLABLE':
            print FBA_quantity.get('Quantity Available')
            amazon_listing = AmazonListingVariations.objects.filter(seller_sku=FBA_quantity.get('seller-sku')).update(quantity=FBA_quantity.get('Quantity Available'))

    # ##获取关系，并保存再一个字典中，key是asin
    print 'FBA存入lisitng中,总共录入了', i, '条'
    print '非FBA:', len(aws_request_product), '条'
    request_product = []
    request_asin = []
    for item in aws_request_product:
        request_asin.append(item.get('asin1'))
        request_product.append(item)
        if len(request_asin) >= 10:
            time.sleep(5)
            print request_asin
            relationship_item = {}
            try:
                relationship_item = my_mws.get_product_product_relationship(list(set(request_asin)))
            except Exception,e:
                print "relationship_item,first", e
                num = 0
                while num <= 5:
                    time.sleep(5)
                    try:
                        relationship_item = my_mws.get_product_product_relationship(list(set(request_asin)))
                    except Exception, e:
                        print "relationship_item,second", num, e
                        pass
                    print "----------------",relationship_item
                    if relationship_item:
                        print relationship_item
                        break
                    num += 1
                if not relationship_item:
                    time_out_request.extend(request_asin)
            print "333333333333333333"
            create_listing_and_variations(account, request_product, relationship_item)
            request_asin = []
            request_product = []

    if len(request_asin) > 0:
        time.sleep(5)
        try:
            relationship_item = my_mws.get_product_product_relationship(request_asin)
        except Exception, e:
            print "relationship_item,first", e
            num = 0
            while num <= 5:
                time.sleep(5)
                try:
                    relationship_item = my_mws.get_product_product_relationship(request_asin)
                except Exception, e:
                    print "relationship_item,second", num, e
                    pass
                if relationship_item:
                    break
                num += 1
            if not relationship_item:
                time_out_request.extend(request_asin)
        create_listing_and_variations(account, request_product, relationship_item)
    print "end"
    return time_out_request

if __name__ == "__main__":
    my_aws = Amazon_AWS()
    # for return_product in return_data.get('data'):
    #     if not return_data:
    #         continue
    #     asinlist.append(return_product.get('item.ASIN.textasin1'))
    #     if len(asinlist) >= 10:
    #         my_aws.get_print len(xml_obj.Items)product_attributes(asinlist, local="US")
    #         asinlist = []
    # if len(asinlist) >= 0:              sale_amazon/test/test1.py:16
    # asinlist = ['B06XGXHHMN','B06XGJ869W','B01N19W31W']
    # asinlist = ['B071RYCDMR']
    # asinlist2=['*nan*20170221-HD0']
    # asinlist = ['B01MR414LY', 'B01MT4LSE1', 'B01N5KZFB9', 'B01N7OCV8I', 'B01NCV0QPI', 'B01N5OKGWY', 'B01N3384P4', 'B01MUA10GB', 'B01N5Y68UL', 'B01MYH4SXM']
    # my_aws.get_items_ids(asinlist,local="US")
    # my_aws.get_product_variations(asinlist, local="US")
    # my_aws.get_product_attributes(asinlist, local="US")
    # my_aws.get_product_images(asinlist, local="US")
    # print my_aws.get_product_large(asinlist, local="US")
    # print my_aws.get_product_large(asinlist2, local="US")
    # my_aws.get_product_editorial_review(asinlist, local="US")
    # my_aws.get_product_offers_full(asinlist,local="US")
    print str(test_sync())
    print "好快啊"